Option Explicit On 

Public Class ctlKeyPad
    Inherits System.Windows.Forms.UserControl

    '--------------- EVENTS -------------------------------------------------------------------------
    '
    Public Event EnterClicked(ByVal vEntry As String)
    Public Event Key(ByVal vLastEntry As String)
    Public Event ValueChanged(ByVal vNewValue As String)

    '--------------- PROPERTIES ---------------------------------------------------------------------
    '
    Private wrkBackcolor As Color
    Private wrkDisplayHidden As Boolean
    Private wrkErrorBeepOn As Boolean
    Private wrkFont As Font
    Private wrkLastEntry As String
    Private wrkUseAmbient As Boolean


    '--------------- INTERNAL VARIABLES -------------------------------------------------------------
    '
    Private DecimalEntered As Boolean
    Private MinusEntered As Boolean
    Private savBackColor As Object
    Private ConstituentCtl As Control
    'Private WithEvents KPFont As StdFont

    'Public Overrides Property BackColor() As Color
    '    Get
    '        Return wrkBackcolor
    '    End Get
    '    Set(ByVal Value As Color)
    '        wrkBackcolor = Value
    '        MyBase.BackColor = wrkBackcolor
    '    End Set

    'End Property

    Public Property DisplayHidden() As Boolean
        Get
            Return wrkDisplayHidden
        End Get
        Set(ByVal Value As Boolean)
            wrkDisplayHidden = Value
            If wrkDisplayHidden Then
                txtDisplay.Visible = False
            Else
                txtDisplay.Visible = True
            End If
        End Set
    End Property
    Public Property ErrorBeepON() As Boolean
        Get
            Return wrkErrorBeepOn
        End Get
        Set(ByVal Value As Boolean)
            wrkErrorBeepOn = Value
        End Set
    End Property
    Public ReadOnly Property LastEntry() As String
        Get
            Return wrkLastEntry
        End Get
    End Property

    Public ReadOnly Property Value() As String
        Get
            Return txtDisplay.Text
        End Get
    End Property

    Public Sub Clear()
        txtDisplay.Text = ""
        DecimalEntered = False
        MinusEntered = False
        wrkLastEntry = "PRGCLR"

    End Sub
    Public Sub SetValue(ByRef vValue As String)
        txtDisplay.Text = vValue
        If InStr(vValue, "-") = 0 Then
            MinusEntered = False
        Else
            MinusEntered = True
        End If
        If InStr(vValue, ".") = 0 Then
            DecimalEntered = False
        Else
            DecimalEntered = True
        End If
        wrkLastEntry = "PRGSET"
        RaiseEvent ValueChanged(txtDisplay.Text)
    End Sub

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl1 overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Button1 As System.Windows.Forms.Button
    Friend WithEvents Button2 As System.Windows.Forms.Button
    Friend WithEvents Button3 As System.Windows.Forms.Button
    Friend WithEvents Button4 As System.Windows.Forms.Button
    Friend WithEvents Button5 As System.Windows.Forms.Button
    Friend WithEvents Button6 As System.Windows.Forms.Button
    Friend WithEvents Button7 As System.Windows.Forms.Button
    Friend WithEvents Button8 As System.Windows.Forms.Button
    Friend WithEvents Button9 As System.Windows.Forms.Button
    Friend WithEvents Button0 As System.Windows.Forms.Button
    Friend WithEvents btnDecimal As System.Windows.Forms.Button
    Friend WithEvents btnMinus As System.Windows.Forms.Button
    Friend WithEvents btnEnter As System.Windows.Forms.Button
    Friend WithEvents txtDisplay As System.Windows.Forms.TextBox
    Friend WithEvents btnClr As System.Windows.Forms.Button
    Friend WithEvents btnDelete As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Button1 = New System.Windows.Forms.Button
        Me.Button2 = New System.Windows.Forms.Button
        Me.Button3 = New System.Windows.Forms.Button
        Me.Button4 = New System.Windows.Forms.Button
        Me.Button5 = New System.Windows.Forms.Button
        Me.Button6 = New System.Windows.Forms.Button
        Me.Button7 = New System.Windows.Forms.Button
        Me.Button8 = New System.Windows.Forms.Button
        Me.Button9 = New System.Windows.Forms.Button
        Me.Button0 = New System.Windows.Forms.Button
        Me.btnDecimal = New System.Windows.Forms.Button
        Me.btnMinus = New System.Windows.Forms.Button
        Me.btnEnter = New System.Windows.Forms.Button
        Me.txtDisplay = New System.Windows.Forms.TextBox
        Me.btnClr = New System.Windows.Forms.Button
        Me.btnDelete = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'Button1
        '
        Me.Button1.Font = New System.Drawing.Font("Microsoft Sans Serif", 20.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Button1.Location = New System.Drawing.Point(8, 128)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(32, 32)
        Me.Button1.TabIndex = 0
        Me.Button1.Text = "1"
        '
        'Button2
        '
        Me.Button2.Font = New System.Drawing.Font("Microsoft Sans Serif", 20.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Button2.Location = New System.Drawing.Point(48, 128)
        Me.Button2.Name = "Button2"
        Me.Button2.Size = New System.Drawing.Size(32, 32)
        Me.Button2.TabIndex = 0
        Me.Button2.Text = "2"
        '
        'Button3
        '
        Me.Button3.Font = New System.Drawing.Font("Microsoft Sans Serif", 20.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Button3.Location = New System.Drawing.Point(88, 128)
        Me.Button3.Name = "Button3"
        Me.Button3.Size = New System.Drawing.Size(32, 32)
        Me.Button3.TabIndex = 0
        Me.Button3.Text = "3"
        '
        'Button4
        '
        Me.Button4.Font = New System.Drawing.Font("Microsoft Sans Serif", 20.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Button4.Location = New System.Drawing.Point(8, 88)
        Me.Button4.Name = "Button4"
        Me.Button4.Size = New System.Drawing.Size(32, 32)
        Me.Button4.TabIndex = 0
        Me.Button4.Text = "4"
        '
        'Button5
        '
        Me.Button5.Font = New System.Drawing.Font("Microsoft Sans Serif", 20.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Button5.Location = New System.Drawing.Point(48, 88)
        Me.Button5.Name = "Button5"
        Me.Button5.Size = New System.Drawing.Size(32, 32)
        Me.Button5.TabIndex = 0
        Me.Button5.Text = "5"
        '
        'Button6
        '
        Me.Button6.Font = New System.Drawing.Font("Microsoft Sans Serif", 20.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Button6.Location = New System.Drawing.Point(88, 88)
        Me.Button6.Name = "Button6"
        Me.Button6.Size = New System.Drawing.Size(32, 32)
        Me.Button6.TabIndex = 0
        Me.Button6.Text = "6"
        '
        'Button7
        '
        Me.Button7.Font = New System.Drawing.Font("Microsoft Sans Serif", 20.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Button7.Location = New System.Drawing.Point(8, 48)
        Me.Button7.Name = "Button7"
        Me.Button7.Size = New System.Drawing.Size(32, 32)
        Me.Button7.TabIndex = 0
        Me.Button7.Text = "7"
        '
        'Button8
        '
        Me.Button8.Font = New System.Drawing.Font("Microsoft Sans Serif", 20.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Button8.Location = New System.Drawing.Point(48, 48)
        Me.Button8.Name = "Button8"
        Me.Button8.Size = New System.Drawing.Size(32, 32)
        Me.Button8.TabIndex = 0
        Me.Button8.Text = "8"
        '
        'Button9
        '
        Me.Button9.Font = New System.Drawing.Font("Microsoft Sans Serif", 20.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Button9.Location = New System.Drawing.Point(88, 48)
        Me.Button9.Name = "Button9"
        Me.Button9.Size = New System.Drawing.Size(32, 32)
        Me.Button9.TabIndex = 0
        Me.Button9.Text = "9"
        '
        'Button0
        '
        Me.Button0.Font = New System.Drawing.Font("Microsoft Sans Serif", 20.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Button0.Location = New System.Drawing.Point(8, 168)
        Me.Button0.Name = "Button0"
        Me.Button0.Size = New System.Drawing.Size(32, 32)
        Me.Button0.TabIndex = 0
        Me.Button0.Text = "0"
        '
        'btnDecimal
        '
        Me.btnDecimal.Font = New System.Drawing.Font("Microsoft Sans Serif", 20.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnDecimal.Location = New System.Drawing.Point(48, 168)
        Me.btnDecimal.Name = "btnDecimal"
        Me.btnDecimal.Size = New System.Drawing.Size(32, 32)
        Me.btnDecimal.TabIndex = 1
        Me.btnDecimal.Text = "."
        '
        'btnMinus
        '
        Me.btnMinus.Font = New System.Drawing.Font("Microsoft Sans Serif", 20.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnMinus.Location = New System.Drawing.Point(88, 168)
        Me.btnMinus.Name = "btnMinus"
        Me.btnMinus.Size = New System.Drawing.Size(32, 32)
        Me.btnMinus.TabIndex = 0
        Me.btnMinus.Text = "-"
        '
        'btnEnter
        '
        Me.btnEnter.Font = New System.Drawing.Font("Microsoft Sans Serif", 18.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnEnter.Location = New System.Drawing.Point(8, 208)
        Me.btnEnter.Name = "btnEnter"
        Me.btnEnter.Size = New System.Drawing.Size(112, 32)
        Me.btnEnter.TabIndex = 0
        Me.btnEnter.Text = "ENTER"
        '
        'txtDisplay
        '
        Me.txtDisplay.Font = New System.Drawing.Font("Microsoft Sans Serif", 15.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtDisplay.Location = New System.Drawing.Point(8, 8)
        Me.txtDisplay.Name = "txtDisplay"
        Me.txtDisplay.Size = New System.Drawing.Size(152, 31)
        Me.txtDisplay.TabIndex = 0
        Me.txtDisplay.Text = ""
        Me.txtDisplay.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'btnClr
        '
        Me.btnClr.Font = New System.Drawing.Font("Microsoft Sans Serif", 20.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnClr.Location = New System.Drawing.Point(128, 48)
        Me.btnClr.Name = "btnClr"
        Me.btnClr.Size = New System.Drawing.Size(32, 92)
        Me.btnClr.TabIndex = 2
        Me.btnClr.Text = "CLR"
        '
        'btnDelete
        '
        Me.btnDelete.Font = New System.Drawing.Font("Microsoft Sans Serif", 20.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnDelete.Location = New System.Drawing.Point(128, 148)
        Me.btnDelete.Name = "btnDelete"
        Me.btnDelete.Size = New System.Drawing.Size(32, 92)
        Me.btnDelete.TabIndex = 3
        Me.btnDelete.Text = "DEL"
        '
        'ctlKeyPad
        '
        Me.Controls.Add(Me.btnDelete)
        Me.Controls.Add(Me.btnClr)
        Me.Controls.Add(Me.txtDisplay)
        Me.Controls.Add(Me.btnEnter)
        Me.Controls.Add(Me.btnMinus)
        Me.Controls.Add(Me.btnDecimal)
        Me.Controls.Add(Me.Button0)
        Me.Controls.Add(Me.Button9)
        Me.Controls.Add(Me.Button8)
        Me.Controls.Add(Me.Button7)
        Me.Controls.Add(Me.Button6)
        Me.Controls.Add(Me.Button5)
        Me.Controls.Add(Me.Button4)
        Me.Controls.Add(Me.Button3)
        Me.Controls.Add(Me.Button2)
        Me.Controls.Add(Me.Button1)
        Me.Font = New System.Drawing.Font("Microsoft Sans Serif", 20.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Name = "ctlKeyPad"
        Me.Size = New System.Drawing.Size(168, 248)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub btnClr_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClr.Click
        txtDisplay.Text = ""
        DecimalEntered = False
        MinusEntered = False
        wrkLastEntry = "CLR"
        RaiseEvent Key(wrkLastEntry)
    End Sub

    Private Sub btnDecimal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDecimal.Click
        If Not DecimalEntered Then
            txtDisplay.Text = txtDisplay.Text & "."
            wrkLastEntry = "."
            DecimalEntered = True
            RaiseEvent Key(wrkLastEntry)
        Else
            If ErrorBeepON Then
                Beep()
            End If
        End If
    End Sub


    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        Dim DelChr As String
        If Len(txtDisplay.Text) <> 0 Then
            DelChr = Microsoft.VisualBasic.Right(txtDisplay.Text, 1)
            txtDisplay.Text = Microsoft.VisualBasic.Left(txtDisplay.Text, (Len(txtDisplay.Text) - 1))
            If DelChr = "." Then
                DecimalEntered = False
            End If
            If DelChr = "-" Then
                MinusEntered = False
            End If
        End If
        wrkLastEntry = "DEL" & DelChr
        RaiseEvent Key(wrkLastEntry)
    End Sub

    Private Sub btnEnter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnter.Click
        RaiseEvent EnterClicked(txtDisplay.Text)
    End Sub

    Private Sub btnMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMinus.Click
        If MinusEntered Then
            txtDisplay.Text = Microsoft.VisualBasic.Right(txtDisplay.Text, (Len(txtDisplay.Text) - 1))
            wrkLastEntry = "+"
            MinusEntered = False
            RaiseEvent Key(wrkLastEntry)
        Else
            txtDisplay.Text = "-" & txtDisplay.Text
            wrkLastEntry = "-"
            MinusEntered = True
            RaiseEvent Key(wrkLastEntry)
        End If

    End Sub

    Private Sub NmbrKey_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
        Handles Button0.Click, Button1.Click, Button2.Click, Button3.Click, Button4.Click, _
                Button5.Click, Button6.Click, Button7.Click, Button8.Click, Button9.Click
        Dim strNmbr As String
        Select Case sender.name
            Case "Button0"
                strNmbr = "0"
            Case "Button1"
                strNmbr = "1"
            Case "Button2"
                strNmbr = "2"
            Case "Button3"
                strNmbr = "3"
            Case "Button4"
                strNmbr = "4"
            Case "Button5"
                strNmbr = "5"
            Case "Button6"
                strNmbr = "6"
            Case "Button7"
                strNmbr = "7"
            Case "Button8"
                strNmbr = "8"
            Case "Button9"
                strNmbr = "9"
        End Select
        txtDisplay.Text = txtDisplay.Text & strNmbr
        wrkLastEntry = strNmbr
        RaiseEvent Key(wrkLastEntry)
    End Sub
End Class
